# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Redis::Mgmt::V2015_08_01
  module Models
    #
    # Parameters supplied to CreateOrUpdate Redis operation.
    #
    class RedisProperties

      include MsRestAzure

      # @return [String] RedisVersion parameter has been deprecated. As such,
      # it is no longer necessary to provide this parameter and any value
      # specified is ignored.
      attr_accessor :redis_version

      # @return [Sku] What SKU of Redis cache to deploy.
      attr_accessor :sku

      # @return [Hash{String => String}] All Redis Settings. Few possible keys:
      # rdb-backup-enabled,rdb-storage-connection-string,rdb-backup-frequency,maxmemory-delta,maxmemory-policy,notify-keyspace-events,maxmemory-samples,slowlog-log-slower-than,slowlog-max-len,list-max-ziplist-entries,list-max-ziplist-value,hash-max-ziplist-entries,hash-max-ziplist-value,set-max-intset-entries,zset-max-ziplist-entries,zset-max-ziplist-value
      # etc.
      attr_accessor :redis_configuration

      # @return [Boolean] If the value is true, then the non-SLL Redis server
      # port (6379) will be enabled.
      attr_accessor :enable_non_ssl_port

      # @return [Hash{String => String}] tenantSettings
      attr_accessor :tenant_settings

      # @return [Integer] The number of shards to be created on a Premium
      # Cluster Cache.
      attr_accessor :shard_count

      # @return [String] The exact ARM resource ID of the virtual network to
      # deploy the Redis cache in. Example format:
      # /subscriptions/{subscriptionId}/resourceGroups/{resourceGroupName}/Microsoft.ClassicNetwork/VirtualNetworks/vnet1
      attr_accessor :virtual_network

      # @return [String] Required when deploying a Redis cache inside an
      # existing Azure Virtual Network.
      attr_accessor :subnet

      # @return [String] Required when deploying a Redis cache inside an
      # existing Azure Virtual Network.
      attr_accessor :static_ip


      #
      # Mapper for RedisProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RedisProperties',
          type: {
            name: 'Composite',
            class_name: 'RedisProperties',
            model_properties: {
              redis_version: {
                client_side_validation: true,
                required: false,
                serialized_name: 'redisVersion',
                type: {
                  name: 'String'
                }
              },
              sku: {
                client_side_validation: true,
                required: true,
                serialized_name: 'sku',
                type: {
                  name: 'Composite',
                  class_name: 'Sku'
                }
              },
              redis_configuration: {
                client_side_validation: true,
                required: false,
                serialized_name: 'redisConfiguration',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              enable_non_ssl_port: {
                client_side_validation: true,
                required: false,
                serialized_name: 'enableNonSslPort',
                type: {
                  name: 'Boolean'
                }
              },
              tenant_settings: {
                client_side_validation: true,
                required: false,
                serialized_name: 'tenantSettings',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              shard_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'shardCount',
                type: {
                  name: 'Number'
                }
              },
              virtual_network: {
                client_side_validation: true,
                required: false,
                serialized_name: 'virtualNetwork',
                type: {
                  name: 'String'
                }
              },
              subnet: {
                client_side_validation: true,
                required: false,
                serialized_name: 'subnet',
                type: {
                  name: 'String'
                }
              },
              static_ip: {
                client_side_validation: true,
                required: false,
                serialized_name: 'staticIP',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
